﻿Sys.UI.AutoResizeTextArea = function(associatedElement) {
    Sys.UI.AutoResizeTextArea.initializeBase(this, [associatedElement]);
    
    var _minRowCount = this.element.rows ? this.element.rows : 3;
    var _maxRowCount = 7;
    
    var _keyUpHandler;
    
    this.get_minRowCount = function() {
        return _minRowCount;
    }
    this.set_minRowCount = function(value) {
        if (_minRowCount != value) {
            _minRowCount = value;
            this._onkeyUp();
            this.raisePropertyChanged('minRowCount');
        }
    }
    this.get_maxRowCount = function() {
        return _maxRowCount;
    }
    this.set_maxRowCount = function(value) {
        if (_maxRowCount != value) {
            _maxRowCount = value;
            this._onkeyUp();
            this.raisePropertyChanged('maxRowCount');
        }
    }
    
    this.initialize = function() {
        Sys.UI.AutoResizeTextArea.callBaseMethod(this, 'initialize');

        _keyUpHandler = Function.createDelegate(this, this._onkeyUp);
        this.element.attachEvent('onkeyup', _keyUpHandler);
        
        this._onkeyUp();
    }

    this.dispose = function() {
        if (_keyUpHandler) {
            this.element.detachEvent('onkeyup', _keyUpHandler);
            _keyUpHandler = null;
        }
        
        Sys.UI.AutoResizeTextArea.callBaseMethod(this, 'dispose');
    }

    this.getDescriptor = function() {
        var td = Sys.UI.AutoResizeTextArea.callBaseMethod(this, 'getDescriptor');
        
        td.addProperty('minRowCount', Number);
        td.addProperty('maxRowCount', Number);
        return td;
    }
    Sys.UI.AutoResizeTextArea.registerBaseMethod(this, 'getDescriptor');
    
    this._onkeyUp = function() {
        while (this.element.scrollHeight > this.element.clientHeight && this.element.rows < _maxRowCount) {
            this.element.rows++;
        }
        while (this.element.scrollHeight < this.element.clientHeight && this.element.rows > _minRowCount) {
            this.element.rows--;
        }
        if (this.element.scrollHeight == this.element.clientHeight) {
            return;
        }
        this.element.style.overflow = this.element.scrollHeight > this.element.clientHeight ? "auto" : "hidden";
    }
}
Sys.UI.AutoResizeTextArea.registerClass('Sys.UI.AutoResizeTextArea', Sys.UI.TextBox);
Sys.TypeDescriptor.addType('script', 'autoResizeTextArea', Sys.UI.AutoResizeTextArea);